#include <miemath.h>


//COSTANTI
double  pi       = 3.1415926535897932385;   //PiGreco
//VARIABILI
float   Velmax,Angmax; // Velocit di variazione, Angolo max di variazione

//
//        by Diego Bonata 1997
//
// FUNZIONE      : GtoR,RtoG,GtoH,HtoG
// VAR.PASSATE   : (double) angolo passato
// VAR.RESTITUITE: valore dell'angolo convertito
// INCLUDE       : math.h
// DESCRIZIONE   :
//  GtoR ->Routine di conversione da Gradi a Radianti
//  RtoG ->Routine di conversione da Radianti a Gradi
//  GtoH ->Routine di conversione da Gradi in Ore
//  HtoG ->Routine di conversione da Ore in Gradi

// Routine di conversione di Gradi in radianti
double GtoR (double gradi)    {   return (gradi * 0.01745329252);    }

// Routine di conversione di radianti in Gradi
double RtoG (double radianti) {   return (radianti * 57.29577951);   }

// Routine di conversione di Gradi in Ore
double GtoH (double gradi)    {   return (gradi / 15);   }

// Routine di conversione di Ore in Gradi
double HtoG (double ore)      {   return (ore * 15);     }

//
//        by Diego Bonata 1997
//
// FUNZIONE      : DECtoGRAD
// VAR.PASSATE   : (double) gradi
// VAR.RESTITUITE: (int) *gg,*mm,*ss= gradi (o ore),minuti,secondi
// INCLUDE       : math.h
// DESCRIZIONE   :
//conversione da gg.dddddd -> gg mm' ss"
int DECtoGRAD (double gradi, int *gg,int *mm,int *ss)
{
double sup;
int   SEGNO=1;

 if (gradi<0) { gradi=-gradi; SEGNO=-1; }

 *gg = (int)gradi;
 *mm = (int)((gradi - *gg)*60);
 sup = ((gradi- *gg)*60 - *mm)*60;
 *ss = (int)sup;

 if (sup>59.5) {
    *ss=0;
    if (*mm==59) {
       *mm=0;
       (*gg)++;
    }
    else (*mm)++;
 }
 else if (sup-(*ss)>.5) (*ss)++;
 *gg=SEGNO*(*gg);

return 0;
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : GRADtoDEC
// VAR.PASSATE   : gg,mm,ss=(int) gradi (o ore),minuti,secondi
// VAR.RESTITUITE: (double) valore decimale in gradi oppure in ore
// INCLUDE       : math.h
// DESCRIZIONE   :
//conversione da gg mm' ss"-> gg.dddddd
double GRADtoDEC (int gg,int mm, int ss)
{
int   SEGNO=1;
float GRAD;

 if (gg<0) { gg=-gg; SEGNO=-1; }

return (SEGNO*((float)gg + ((float)mm)/60 + ((float)ss)/3600));
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : IMin
// VAR.PASSATE   : val1,val2= (int) valori
// VAR.RESTITUITE: (int) valore minore dei 2 passati
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce il minore fra 2 valori interi
int IMin (int val1, int val2)
{
 if (val1<=val2) return val1;
return val2;
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : IMax
// VAR.PASSATE   : val1,val2= (int) valori
// VAR.RESTITUITE: (int) valore maggiore dei 2 passati
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce il maggiore fra 2 valori interi
int IMax (int val1, int val2)
{
 if (val1<=val2) return val2;
return val1;
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : DMin
// VAR.PASSATE   : val1,val2= (double) valori
// VAR.RESTITUITE: (double) valore minore dei 2 passati
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce il minore fra 2 valori double
double DMin (double val1, double val2)
{
 if (val1<=val2) return val1;
return val2;
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : DMax
// VAR.PASSATE   : val1,val2= (double) valori
// VAR.RESTITUITE: (double) valore maggiore dei 2 passati
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce il maggiore fra 2 valori double
double DMax (double val1, double val2)
{
 if (val1<=val2) return val2;
return val1;
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Trunc
// VAR.PASSATE   : val= (double) valore
// VAR.RESTITUITE: (double) parte intera del valore inserito
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce la parte intera di un double
double Trunc(double val)
{
double supp;

  modf(val, &supp);
return (supp);
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Round
// VAR.PASSATE   : val= (double) valore
// VAR.RESTITUITE: (long) parte intera del valore inserito
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce l'orrotondamento di un double a un long int
long Round(double val)
{
double supp,resto;

 resto=modf(val,&supp);
 if (resto>.5) supp=supp+1;
return ((long)supp);
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Sign
// VAR.PASSATE   : val= (double) valore
// VAR.RESTITUITE: (int) restituisce il segno + o - 1
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce il segno di un double
int Sign(double val)
{
 if (val>0)      return 1;
 else if (val<0) return -1;
return 0;
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Cube
// VAR.PASSATE   : arg= (double) valore
// VAR.RESTITUITE: (double) restituisce il cubo di un valore
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce il cubo di un double
double Cube (double arg)  { return arg*arg*arg; }

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Power
// VAR.PASSATE   : (double) val=valore pwr=esponente
// VAR.RESTITUITE: (double) restituisce val^pwr
// INCLUDE       : math.h
// DESCRIZIONE   :
// Routile elevamento a potenza val^pwr
double Power(double val, double pwr)
{
 if (val>0) return (exp(pwr*log(val)));
 else {
   //printf("Invalid argument in Function Power!");
   return -1;
 }
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Modulus
// VAR.PASSATE   : (double) arg1= valore da ridurre
//               : (double) arg2= valore di riduzione (se=360 la
//                 funzione diventa uguale a Riduci
// VAR.RESTITUITE: (double) restituisce il valore ridotto nell'intevallo
//                 prestabilito
// INCLUDE       : math.h
// DESCRIZIONE   :
// Restituisce un numero compreso fra 0 e 360 o 0 e piGreco (Tipo Riduci)
double Modulus(double arg1,double arg2)
{
double modu,supp;

  modu = arg1 - Trunc(arg1/arg2) * arg2;
  if (modu>=0)  return (modu);
  else          return (modu + arg2);
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Fmod2p
// VAR.PASSATE   : (double) arg= val.da ridurre ad uno compreso fra 0 e pigreco
// VAR.RESTITUITE: (double) valore ridotto nell'intevallo fra 0 o pigreco
// INCLUDE       : math.h
// DESCRIZIONE   :
// Restituisce un numero compreso fra 0 e piGreco (Tipo Riduci ma con radianti)
double Fmod2p(double arg)
{
  return (Modulus(arg,2*M_PI));
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Riduci
// VAR.PASSATE   : (double) angolo > 360 gradi
// VAR.RESTITUITE: (double) angolo ridotto fra -360 e 360 gradi
// INCLUDE       : math.h
// DESCRIZIONE   :
// Routile di riduzione dell' angolo ad uno compreso fra -360 e 360 gradi
double Riduci (register double gradi)
{
double h;
double pl;

 if (gradi<=-360 || gradi>=360) {
    pl = gradi/360;
    if  (pl<0) pl = -pl;
    pl =(int)  pl;
    h  = pl * 360;
    if (gradi>=360) gradi = gradi - h;
    else            gradi = gradi + h;
 }
 return (gradi);
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : cambia_quadr
// VAR.PASSATE   : (double) a =valore della tangente (gradi)
// 	           (double) a1=valore del seno (indifferente gradi o radianti)
// 	           (double) a2=valore del seno (indifferente gradi o radianti)
// VAR.RESTITUITE: (double) valore della tangente nel giusto quadrante (gradi)
// INCLUDE       : math.h
// DESCRIZIONE   :
// Routine di cambiamento del quadrante
// Restituisce l'angolo nel giusto quadrante in gradi
double cambia_quadr(double a,double a1,double a2)
{
  if (a1>=0.0) {
     if (a2<0.0)      a = 180 + a;
  }
  else {
     if (a2>=0.0)     a = 360 + a;
     else             a = 180 + a;
  }
  return(a);
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : AcTan
// VAR.PASSATE   : sinx=(double) seno (radianti) dell'angolo
//		   cosx=(double) coseno (radianti) dell'angolo
// VAR.RESTITUITE: (double) valore della tangente dell'angolo (radianti)
// INCLUDE       : math.h
// DESCRIZIONE   :
// Restituisce la tangente di un angolo nel giusto quadrante
// e senza nessun problema di infiniti
/* ESEMPIO:
void main(void)
{
double A;

clrscr();
 A=RtoG(AcTan(.12234,2.344));
 printf("\n*1/1=%.3f*",A);
 getch();
}*/

//Restituisce la tangente nel giusto quadrante
double AcTan(double sinx,double cosx)
{
  if (cosx==0) {
    if (sinx >0) return (pi/2);
    else         return (3*pi/2);
  }
  else if (cosx>0) return (atan(sinx/cosx));
  else             return (pi + atan(sinx/cosx));
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : rotate
// VAR.PASSATE   : *x=(double) coordinata x
//		   *y=(double) coordinata y
//                 *angle= (double) angolo di rotazione del sistema di rif.
// VAR.RESTITUITE: (double) x,y nuove coordinate
// INCLUDE       : math.h
// DESCRIZIONE   :
// Routile di rotazione degli assi 2D
void rotate (double *x,double *y,double *angle)
{
double x_temp=*x;
  *x = x_temp * cos (angle) - *y * sin (angle);
  *y = X_temp * sin (angle) + *y * cos (angle);
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : TraXY
// VAR.PASSATE   : *Oldx=(double) coordinata x
//		   *Oldy=(double) coordinata y
//                 TraslaX,TraslaY= (double) valori delle traslazione degli
//                 assi x e y
// VAR.RESTITUITE: (double) OldX,OldY nuove coordinate traslate
// INCLUDE       : math.h
// DESCRIZIONE   :
// Routine di TRASLAZIONE degli assi x,y
void TraXY (double *OldX,double *OldY,double TraslaX,double TraslaY)
{
*OldX = *OldX - TraslaX;
*OldY = *OldY - TraslaY;
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : clipping
// VAR.PASSATE   : (double) x1,y1,x2,y2=coordinate degli estremi di una retta
//		   (double) Minx,Maxx,Miny,Maxy=dimensioni x,y della finestra
//  	           che deve contenere la retta in questione
// VAR.RESTITUITE: (double) x1,y1,x2,y2=nuove coordinate della retta allo
//                 interno della finestra selezionata
// INCLUDE       : math.h
// DESCRIZIONE   :
// Routile di Clipping o taglio di una retta per mostrarne o prenderne in
// considerazione solo la parte contenuta all'interno di un riquadro
// NB le funzioni: Code, ClipDX,ClipSX,ClipTOP,ClipBOT sono di supporto
int Code (x,y,Minx,Maxx,Miny,Maxy)
double *x,*y,*Minx,*Maxx,*Miny,*Maxy;
{
typedef enum {null,minx,maxx,miny,maxy};
int c=null;

 if (*x<*Minx)       c = minx;
 else if (*x>*Maxx)  c = maxx;
 if (*y<*Miny)       c = c + miny;
 else if (*y>*Maxy)  c = c + maxy;
return c;
}

double ClipDX(Maxx,x,y,x0,y0)
register double *Maxx,*x,*y,*x0,*y0;
{ return ((*y0 - *y) / (*x0 - *x) * (*Maxx - *x) + *y); }

double ClipSX(Minx,x,y,x0,y0)
register double *Minx,*x,*y,*x0,*y0;
{ return ((*y0 - *y) / (*x0 - *x) * (*Minx - *x) + *y); }

double ClipTOP(Maxy,x,y,x0,y0)
register double *Maxy,*x,*y,*x0,*y0;
{ return ((*Maxy - *y) / (*y0 - *y) * (*x0 - *x) + *x); }

double ClipBOT(Miny,x,y,x0,y0)
register double *Miny,*x,*y,*x0,*y0;
{ return ((*Miny - *y) / (*y0 - *y) * (*x0 - *x) + *x); }

int clipping (x1,y1,x2,y2,Minx,Maxx,Miny,Maxy)
register double *x1,*x2,*y1,*y2;
double *Minx,*Maxx,*Miny,*Maxy;
{
int c1,c2;

 c1=Code(x1,y1,Minx,Maxx,Miny,Maxy); c2=Code(x2,y2,Minx,Maxx,Miny,Maxy);
 if (c1==0 && c2==0) return 0;
 if ((*y1>=*Maxy && *y2>=*Maxy) || (*y1<=*Miny && *y2<=*Miny)) return 2;
 if ((*x1>=*Maxx && *x2>=*Maxx) || (*x1<=*Minx && *x2<=*Minx)) return 2;
 if ((*x1>=*Maxx || *x2>=*Maxx)) {
     if (*x1>=*Maxx) { *y1=ClipDX(Maxx,x1,y1,x2,y2); *x1=*Maxx;  }
     if (*x2>=*Maxx) { *y2=ClipDX(Maxx,x2,y2,x1,y1); *x2=*Maxx;  }
 }
 if ((*x1<=*Minx || *x2<=*Minx)) {
     if (*x1<=*Minx) { *y1=ClipSX(Minx,x1,y1,x2,y2); *x1=*Minx;  }
     if (*x2<=*Minx) { *y2=ClipSX(Minx,x2,y2,x1,y1); *x2=*Minx;  }
 }
 if ((*y1>=*Maxy || *y2>=*Maxy)) {
     if (*y1>=*Maxy) { *x1=ClipTOP(Maxy,x1,y1,x2,y2); *y1=*Maxy; }
     if (*y2>=*Maxy) { *x2=ClipTOP(Maxy,x2,y2,x1,y1); *y2=*Maxy; }
 }
 if ((*y1<=*Miny || *y2<=*Miny)) {
     if (*y1<=*Miny) { *x1=ClipBOT(Miny,x1,y1,x2,y2); *y1=*Miny; }
     if (*y2<=*Miny) { *x2=ClipBOT(Miny,x2,y2,x1,y1); *y2=*Miny; }
 }
 c1=Code(x1,y1,Minx,Maxx,Miny,Maxy); c2=Code(x2,y2,Minx,Maxx,Miny,Maxy);
 if (c1!=0 || c2!=0) return 2;

 return 1;
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : stat
// VAR.PASSATE   : (int) ran=Numero casuale
//                 (array di int) stat=numeri che rappresentano la
//                 percentuale di uscita di un determinato valore
// VAR.RESTITUITE: Numero corrispondente alla posizione in stat
// INCLUDE       : time.h, math.h
// DESCRIZIONE   :
// Routile che restituisce le possibilita' che si verifichi una situazione
// anziche un altra.
// Valori passati:
//    ran=numero random
//    stat[]=Matrice di n valori che hanno una certa % di uscire,
//           gli n valori % devono dare una somma totale del 100%
// Valore restituito: elemento t degli n possibili
/* ESEMPIO:
#include <time.h>
#include <math.h>
void main(void)
{
int j,i,caso,STATI[]={25,25,15,10,10,6,4,2,1,1,1};
   clrscr();
   randomize();
   for (j=0;j<100;j++) {
      i=random(100)+1;
      caso=stat(i,&STATI);
      printf("# %d #",caso);
   }
return 0;
}*/
int stat(int ran,int stat[])
{
int Cs,n;

 if (ran==1)  return 0;
 else  n=0;
 Cs=stat[0];
 if (ran<=Cs) return 0;
 else {
    do {
       n++;
       Cs=Cs+stat[n];
       if (ran<=Cs)     return n;
    } while (stat[n]);
 }
 if (Cs>=100) return NOK;
}


//
//        by Diego Bonata 1997
//
// FUNZIONE      : AngPerturbation
// VAR.PASSATE   : Dt=(float) intervallo di tempo delle misure
//		   *CHI,*TETA,*FI= Angoli sui quali viene introdotta
//                 una perturbazione da calcolarsi con la funzione
// VAR.RESTITUITE: *CHI,*TETA,*FI modificati con la perturbazione
// INCLUDE       : time.h, math.h
// DESCRIZIONE   :
// Generatore casuale di 3 angoli all'interno dell'intervallo
// specificato. L'angolo max di variazione attorno a ciascun
// valore definito da CHI,TETA,FI Vale + o - Angmax (gradi),
// mentre la velocit max di variazione vale Velmax (gradi)
// Dt=intervallo di tempo nel quale vengono fatte le misure
/* ESEMPIO:
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
float Velmax=0.02,Angmax=4.8;

void main(void)
{
int   j;
float c,t,f;
   clrscr();
   randomize();
   for (j=0;j<32000;j++) {
       AngPerturbation(1,&c,&t,&f);
       printf("#chi=%.4f  teta=%.4f  fi=%.4f#\n",c,t,f);
   }
   getch();
}*/
void AngPerturbation(float Dt,float *CHI,float *TETA,float *FI)
{
static float chi1=0,chi=0,fi1=0,fi=0,teta1=0,teta=0;//precedenti
float val1,val;
float Acc;
int   i,N;

      //chi
      i=random(2);
      if (i==0) i=-1;
      if (i>=0) {//>=0
	 val1 = (Velmax-chi1)/Dt;
	 val  = 2*(Angmax-chi1*Dt-chi)/(Dt*Dt);
	 N    = random(32000);
	 if (val1<=val) Acc = val1 * N /32000.0;
	 else           Acc = val  * N /32000.0;
      }
      else {     //<0
	 val1 = -(Velmax+chi1)/Dt;
	 val  = -2*(Angmax+chi1*Dt+chi)/(Dt*Dt);
	 N    = random(32000);
	 if (val1>=val) Acc = val1 * N /32000.0;
	 else           Acc = val  * N /32000.0;
      }
      //calcolo Velocita'/Posizione
      chi1=Acc*Dt+chi1;
      chi =Acc*Dt*Dt/2+chi1*Dt+chi;
      //teta
      i=random(2);
      if (i==0) i=-1;
      if (i>=0) {//>=0
	 val1 = (Velmax-teta1)/Dt;
	 val  = 2*(Angmax-teta1*Dt-teta)/(Dt*Dt);
	 N    = random(32000);
	 if (val1<=val) Acc = val1 * N /32000.0;
	 else           Acc = val  * N /32000.0;
      }
      else {     //<0
	 val1 = -(Velmax+teta1)/Dt;
	 val  = -2*(Angmax+teta1*Dt+teta)/(Dt*Dt);
	 N    = random(32000);
	 if (val1>=val) Acc = val1 * N /32000.0;
	 else           Acc = val  * N /32000.0;
      }
      //calcolo Velocita'/Posizione
      teta1=Acc*Dt+teta1;
      teta =Acc*Dt*Dt/2+teta1*Dt+teta;
      //fi
      i=random(2);
      if (i==0) i=-1;
      if (i>=0) {//>=0
	 val1 = (Velmax-fi1)/Dt;
	 val  = 2*(Angmax-fi1*Dt-fi)/(Dt*Dt);
	 N    = random(32000);
	 if (val1<=val) Acc = val1 * N /32000.0;
	 else           Acc = val  * N /32000.0;
      }
      else {     //<0
	 val1 = -(Velmax+fi1)/Dt;
	 val  = -2*(Angmax+fi1*Dt+fi)/(Dt*Dt);
	 N    = random(32000);
	 if (val1>=val) Acc = val1 * N /32000.0;
	 else           Acc = val  * N /32000.0;
      }
      //calcolo Velocita'/Posizione
      fi1 =Acc*Dt+fi1;
      fi  =Acc*Dt*Dt/2+fi1*Dt+fi;

 *CHI =chi*M_PI/180;
 *TETA=teta*M_PI/180;
 *FI  =fi*M_PI/180;
}


//
//        by Diego Bonata 1997
//
// FUNZIONE      : Intersez
// VAR.PASSATE   : x1,y1,x2,y2=(float) coord.estremi della prima retta
//               : x3,y3,x4,y4=(float) coord.estremi della seconda retta
// VAR.RESTITUITE: *xi,*yi= (float) coord.del punto di intersezione
//		   (int) TRUE= se intersezione
//                       FALSE= non intersezione

// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce il punto di intersezione fra 2 rette
//Inoltre se 3 e 4 e' il lato opposto di un triangolo con vertice 1
//restituisce TRUE se il punto 2 e' all'interno del triangolo 134, FALSE se no
int Intersez(float x1,float y1,float x2,float y2,float x3,float y3,
	     float x4,float y4,float *xi,float *yi)
{
float m1,m2,xa3,xa4,ya3,ya4,xa1,xa2,ya1,ya2;
 m1=(y2-y1)/(x2-x1);
 m2=(y4-y3)/(x4-x3);
 if (m1==m2) return FALSE;//non c'e' intersezione
 else{
    *xi=(m2*x3-m1*x1+y1-y3)/(m2-m1);
    *yi=m1*(*xi-x1)+y1;
    if (x3>x4) {  xa3=x3; xa4=x4;  }
    else       {  xa3=x4; xa4=x3;  }
    if (y3>y4) {  ya3=y3; ya4=y4;  }
    else       {  ya3=y4; ya4=y3;  }
    if (*xi>xa4 && *xi<xa3 && *yi>ya4 && *yi<ya3) {
	if (x1>*xi) {  xa1=x1; xa2=*xi;  }
	else        {  xa1=*xi; xa2=x1;  }
	if (y1>*yi) {  ya1=y1; ya2=*yi;  }
	else        {  ya1=*yi; ya2=y1;  }
	if (x2>xa2 && x2<xa1 && y2>ya2 && y2<ya1) return TRUE; //intersez
	else                                      return FALSE;//no intersez
    }
    else return FALSE;//no intersez
 }
 //NB ATTENZIONE: IL PRIMO FALSE INDICA NON INTERSEZIONE MENTRE GLI ULTIMI 2
 //               INDICANO ESTERNOAD UN TRIANGOLO VANNO CAMBIATI
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : AngTwoLine
// VAR.PASSATE   : Pt[3]= (float) coord.origine x,y,z
// VAR.RESTITUITE: Pt1[3],Pt2[3]= (float) coord. degli estremi delle rette
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce l'angolo fra due rette con origine comune Pt
double AngTwoLine(float Pt[3],float Pt1[3],float Pt2[3])
{
double angT,d1,d2;

 d1=sqrt((Pt1[0]-Pt[0])*(Pt1[0]-Pt[0])+(Pt1[1]-Pt[1])*(Pt1[1]-Pt[1])+
	 (Pt1[2]-Pt[2])*(Pt1[2]-Pt[2]));
 d2=sqrt((Pt2[0]-Pt[0])*(Pt2[0]-Pt[0])+(Pt2[1]-Pt[1])*(Pt2[1]-Pt[1])+
	 (Pt2[2]-Pt[2])*(Pt2[2]-Pt[2]));

 angT=acos(((Pt1[0]-Pt[0])*(Pt2[0]-Pt[0])+(Pt1[1]-Pt[1])*(Pt2[1]-Pt[1])+
	    (Pt1[2]-Pt[2])*(Pt2[2]-Pt[2]))/(d1*d2));

return angT;
}

//
//        by Diego Bonata 1997
//
// FUNZIONE      : LUNG
// VAR.PASSATE   : alfa,beta,gamma=(double) parametri della conica
//                 CERCHIO : alfa=1 beta=1 gamma=-2*Raggio (concava) + (convessa)
//                 ELLISSE : alfa=Semiasseminore^2   beta=Semiassemaggiore^2
//                 gamma=-2*Semiasseminore*Semiassemaggiore^2 (concava) + (convessa)
//                 IPERBOLE: alfa=-Semiasseminore^2  beta=Semiassemaggiore^2
//                 gamma=-2*Semiassemaggiore^2 (concava) + (convessa)
//                 PARABOLA: alfa=1/(2*Fuoco) beta=0  gamma=-1 (concava) + (convessa)
//                 Xini=(double) coordinata X di inizio della misura
//                 Xfin=(double) coordinata X di fine della misura
//                 DELTA=(double) approssimazione desiderata >0
// VAR.RESTITUITE: (double) lunghezza tratto di conica
// INCLUDE       : math.h
// DESCRIZIONE   :
// Funzione per calcolare la lunghezza di un arco di una funzione generica
// y=f(x) in coordinate polari
double LUNG(alfa,beta,gamma,Xini,Xfin,DELTA)
double alfa,beta,gamma,Xini,Xfin,DELTA;
{
float arco;
float x,y0,y1,STEP;
int    NIteraz;


STEP   = (Xfin-Xini)/DELTA;
NIteraz= 1;
x      = Xini;
y0 = (-gamma+sqrt(gamma*gamma-4*beta*alfa*x*x))/(2*beta);
arco   = 0.0;
y1     = 0.0;
do {
    x     = x + STEP;
    y1    = gamma*gamma-4*beta*alfa*x*x;
    if (y1>0) y1    = (-gamma+sqrt(y1))/(2*beta);
    else      y1    = (-gamma+sqrt(-y1))/(2*beta);
    arco  = arco + sqrt(STEP*STEP+(y1-y0)*(y1-y0));
    y0    = y1;
    NIteraz++;
} while (NIteraz<=(int)DELTA);

return arco;
}



//aggiungere
/*
// Questa funzione trova il centroide di una serie di punti
// deve essere pero' resaa portabile
void Clustering(void)
{
int    i,P=0;
float  Xm,Ym,xp,x,yp,y,varX,varY,N;
struct xycoord *Cx,*Cy;
char   str[4];

 if (inizX && inizY) {
   for (P=-4;P<4;P++) {
    Cx=inizX;
    Cy=inizY;
    do {
       Cx->Flag=Cy->Flag=1;
       Cx = Cx->succ;
       Cy = Cy->succ;
    } while(Cx && Cy);
    do {
       Xm=Ym=xp=x=yp=y=0;
       Cx=inizX;
       Cy=inizY;
       do {
	  if (Cx->Flag && Cy->Flag) {
	     xp = xp + pow(Cx->Punto,P+1);
	     yp = yp + pow(Cy->Punto,P+1);
	     x  = x  + pow(Cx->Punto,P);
	     y  = y  + pow(Cy->Punto,P);
	  }
	  Cx = Cx->succ;
	  Cy = Cy->succ;
       } while(Cx && Cy);
       Xm=xp/x;
       Ym=yp/y;

       Cx=inizX;
       Cy=inizY;
       x=y=N=0;
       do {
	  if (Cx->Flag && Cy->Flag) {
	     x  = x  + pow(Cx->Punto - Xm,2);
	     y  = y  + pow(Cy->Punto - Ym,2);
	     N++;
	  }
	  Cx = Cx->succ;
	  Cy = Cy->succ;
       } while(Cx && Cy);
       varX = sqrt(x/N);
       varY = sqrt(y/N);

       Cx=inizX;
       Cy=inizY;
       i=0;
       do {
	  if (Cx->Flag && Cy->Flag) {
	     if (fabs(Cx->Punto-Xm)>2*varX) { Cx->Flag=Cy->Flag=0; i++;  }
	     if (fabs(Cy->Punto-Ym)>2*varY) { Cx->Flag=Cy->Flag=0; i++;  }
	  }
	  Cx = Cx->succ;
	  Cy = Cy->succ;
       } while(Cx && Cy);
       setcolor(RED);
       line(mx+Xm-2,my+Ym,mx+Xm+2,my+Ym);line(mx+Xm,my+Ym-2,mx+Xm,my+Ym+2);
       getch();
    }while(i);
    setcolor(LIGHTRED);
    line(mx+Xm-2,my+Ym,mx+Xm+2,my+Ym);line(mx+Xm,my+Ym-2,mx+Xm,my+Ym+2);
    sprintf(str,"%d",P);
    outtextxy(mx+Xm,my+Ym-10,str);
  }//for
 }    //if
}

*/