#include <math.h>

// DEFINIZIONI
#define TRUE  1      /*  logical operators  */
#define FALSE 0
#define OK    0
#define NOK   -1
#define IS    ==
#define ISNOT !=
#define NOT   !
#define OR    ||
#define AND   &&

//COSTANTI
extern double pi;   //PiGreco
//VARIABILI
extern float  Velmax,Angmax; // Velocit di variazione, Angolo max di variazione



//
//        by Diego Bonata 1997
//
// FUNZIONE      : GtoR,RtoG,GtoH,HtoG
// VAR.PASSATE   : (double) angolo passato
// VAR.RESTITUITE: valore dell'angolo convertito
// INCLUDE       : math.h
// DESCRIZIONE   :
//  GtoR ->Routine di conversione da Gradi a Radianti
//  RtoG ->Routine di conversione da Radianti a Gradi
//  GtoH ->Routine di conversione da Gradi in Ore
//  HtoG ->Routine di conversione da Ore in Gradi

// Routile di conversione di Gradi in radianti
double GtoR (double gradi);

// Routile di conversione di radianti in Gradi
double RtoG (double radianti);

// Routile di conversione di Gradi in Ore
double GtoH (double gradi);

// Routile di conversione di Ore in Gradi
double HtoG (double ore);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : DECtoGRAD
// VAR.PASSATE   : (double) gradi
// VAR.RESTITUITE: (int) *gg,*mm,*ss= gradi (o ore),minuti,secondi
// INCLUDE       : math.h
// DESCRIZIONE   :
//conversione da gg.dddddd -> gg mm' ss"
int DECtoGRAD (double gradi, int *gg,int *mm,int *ss);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : GRADtoDEC
// VAR.PASSATE   : gg,mm,ss=(int) gradi (o ore),minuti,secondi
// VAR.RESTITUITE: (double) valore decimale in gradi oppure in ore
// INCLUDE       : math.h
// DESCRIZIONE   :
//conversione da gg mm' ss"-> gg.dddddd
double GRADtoDEC (int gg,int mm, int ss);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : IMin
// VAR.PASSATE   : val1,val2= (int) valori
// VAR.RESTITUITE: (int) valore minore dei 2 passati
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce il minore fra 2 valori interi
int IMin (int val1, int val2);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : IMax
// VAR.PASSATE   : val1,val2= (int) valori
// VAR.RESTITUITE: (int) valore maggiore dei 2 passati
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce il maggiore fra 2 valori interi
int IMax (int val1, int val2);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : DMin
// VAR.PASSATE   : val1,val2= (double) valori
// VAR.RESTITUITE: (double) valore minore dei 2 passati
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce il minore fra 2 valori double
double DMin (double val1, double val2);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : DMax
// VAR.PASSATE   : val1,val2= (double) valori
// VAR.RESTITUITE: (double) valore maggiore dei 2 passati
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce il maggiore fra 2 valori double
double DMax (double val1, double val2);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Trunc
// VAR.PASSATE   : val= (double) valore
// VAR.RESTITUITE: (double) parte intera del valore inserito
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce la parte intera di un double
double Trunc(double val);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Round
// VAR.PASSATE   : val= (double) valore
// VAR.RESTITUITE: (long) parte intera del valore inserito
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce l'orrotondamento di un double a un long int
long Round(double val);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Sign
// VAR.PASSATE   : val= (double) valore
// VAR.RESTITUITE: (int) restituisce il segno + o - 1
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce il segno di un double
int Sign(double val);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Cube
// VAR.PASSATE   : arg= (double) valore
// VAR.RESTITUITE: (double) restituisce il cubo di un valore
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce il cubo di un double
double Cube (double arg);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Power
// VAR.PASSATE   : (double) val=valore pwr=esponente
// VAR.RESTITUITE: (double) restituisce val^pwr
// INCLUDE       : math.h
// DESCRIZIONE   :
// Routile elevamento a potenza val^pwr
double Power(double val, double pwr);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Modulus
// VAR.PASSATE   : (double) arg1= valore da ridurre
//               : (double) arg2= valore di riduzione (se=360 la
//                 funzione diventa uguale a Riduci
// VAR.RESTITUITE: (double) restituisce il valore ridotto nell'intevallo
//                 prestabilito
// INCLUDE       : math.h
// DESCRIZIONE   :
// Restituisce un numero compreso fra 0 e 360 o 0 e piGreco (Tipo Riduci)
double Modulus(double arg1,double arg2);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Fmod2p
// VAR.PASSATE   : (double) arg= val.da ridurre ad uno compreso fra 0 e pigreco
// VAR.RESTITUITE: (double) valore ridotto nell'intevallo fra 0 o pigreco
// INCLUDE       : math.h
// DESCRIZIONE   :
// Restituisce un numero compreso fra 0 e piGreco (Tipo Riduci ma con radianti)
double Fmod2p(double arg);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Riduci
// VAR.PASSATE   : (double) angolo > 360 gradi
// VAR.RESTITUITE: (double) angolo ridotto fra -360 e 360 gradi
// INCLUDE       : math.h
// DESCRIZIONE   :
// Routile di riduzione dell' angolo ad uno compreso fra -360 e 360 gradi
double Riduci (register double gradi);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : cambia_quadr
// VAR.PASSATE   : (double) a =valore della tangente (gradi)
// 	           (double) a1=valore del seno (indifferente gradi o radianti)
// 	           (double) a2=valore del seno (indifferente gradi o radianti)
// VAR.RESTITUITE: (double) valore della tangente nel giusto quadrante (gradi)
// INCLUDE       : math.h
// DESCRIZIONE   :
// Routine di cambiamento del quadrante
// Restituisce l'angolo nel giusto quadrante in gradi
double cambia_quadr(double a,double a1,double a2);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : AcTan
// VAR.PASSATE   : sinx=(double) seno (radianti) dell'angolo
//		   cosx=(double) coseno (radianti) dell'angolo
// VAR.RESTITUITE: (double) valore della tangente dell'angolo (radianti)
// INCLUDE       : math.h
// DESCRIZIONE   :
// Restituisce la tangente di un angolo nel giusto quadrante
// e senza nessun problema di infiniti
/* ESEMPIO:
void main(void)
{
double A;

clrscr();
 A=RtoG(AcTan(.12234,2.344));
 printf("\n*1/1=%.3f*",A);
 getch();
}*/

//Restituisce la tangente nel giusto quadrante
double AcTan(double sinx,double cosx);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : rotate
// VAR.PASSATE   : *x=(double) coordinata x
//		   *y=(double) coordinata y
//                 *angle= (double) angolo di rotazione del sistema di rif.
// VAR.RESTITUITE: (double) x,y nuove coordinate
// INCLUDE       : math.h
// DESCRIZIONE   :
// Routile di rotazione degli assi 2D
void rotate (double *x,double *y,double *angle);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : TraXY
// VAR.PASSATE   : *Oldx=(double) coordinata x
//		   *Oldy=(double) coordinata y
//                 TraslaX,TraslaY= (double) valori delle traslazione degli
//                 assi x e y
// VAR.RESTITUITE: (double) OldX,OldY nuove coordinate traslate
// INCLUDE       : math.h
// DESCRIZIONE   :
// Routine di TRASLAZIONE degli assi x,y
void TraXY (double *OldX,double *OldY,double TraslaX,double TraslaY);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : clipping
// VAR.PASSATE   : (double) x1,y1,x2,y2=coordinate degli estremi di una retta
//		   (double) Minx,Maxx,Miny,Maxy=dimensioni x,y della finestra
//  	           che deve contenere la retta in questione
// VAR.RESTITUITE: (double) x1,y1,x2,y2=nuove coordinate della retta allo
//                 interno della finestra selezionata
// INCLUDE       : math.h
// DESCRIZIONE   :
// Routile di Clipping o taglio di una retta per mostrarne o prenderne in
// considerazione solo la parte contenuta all'interno di un riquadro
// NB le funzioni: Code, ClipDX,ClipSX,ClipTOP,ClipBOT sono di supporto
int Code (double *x,double *y,double *Minx,double *Maxx,double *Miny,double *Maxy);

double ClipDX(double *Maxx,double *x,double *y,double *x0,double *y0);

double ClipSX(double *Minx,double *x,double *y,double *x0,double *y0);

double ClipTOP(double *Maxy,double *x,double *y,double *x0,double *y0);

double ClipBOT(double *Miny,double *x,double *y,double *x0,double *y0);

int clipping (double *x1,double *y1,double *x2,double *y2,double *Minx,double *Maxx,double *Miny,double *Maxy);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : stat
// VAR.PASSATE   : (int) ran=Numero casuale
//                 (array di int) stat=numeri che rappresentano la
//                 percentuale di uscita di un determinato valore
// VAR.RESTITUITE: Numero corrispondente alla posizione in stat
// INCLUDE       : time.h, math.h
// DESCRIZIONE   :
// Routile che restituisce le possibilita' che si verifichi una situazione
// anziche un altra.
// Valori passati:
//    ran=numero random
//    stat[]=Matrice di n valori che hanno una certa % di uscire,
//           gli n valori % devono dare una somma totale del 100%
// Valore restituito: elemento t degli n possibili
/* ESEMPIO:
#include <time.h>
#include <math.h>
void main(void)
{
int j,i,caso,STATI[]={25,25,15,10,10,6,4,2,1,1,1};
   clrscr();
   randomize();
   for (j=0;j<100;j++) {
      i=random(100)+1;
      caso=stat(i,&STATI);
      printf("# %d #",caso);
   }
return 0;
}*/
int stat(int ran,int stat[]);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : AngPerturbation
// VAR.PASSATE   : Dt=(float) intervallo di tempo delle misure
//		   *CHI,*TETA,*FI= Angoli sui quali viene introdotta
//                 una perturbazione da calcolarsi con la funzione
// VAR.RESTITUITE: *CHI,*TETA,*FI modificati con la perturbazione
// INCLUDE       : time.h, math.h
// DESCRIZIONE   :
// Generatore casuale di 3 angoli all'interno dell'intervallo
// specificato. L'angolo max di variazione attorno a ciascun
// valore definito da CHI,TETA,FI Vale + o - Angmax (gradi),
// mentre la velocit max di variazione vale Velmax (gradi)
// Dt=intervallo di tempo nel quale vengono fatte le misure
/* ESEMPIO:
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
float Velmax=0.02,Angmax=4.8;

void main(void)
{
int   j;
float c,t,f;
   clrscr();
   randomize();
   for (j=0;j<32000;j++) {
       AngPerturbation(1,&c,&t,&f);
       printf("#chi=%.4f  teta=%.4f  fi=%.4f#\n",c,t,f);
   }
   getch();
}*/
void AngPerturbation(float Dt,float *CHI,float *TETA,float *FI);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : Intersez
// VAR.PASSATE   : x1,y1,x2,y2=(float) coord.estremi della prima retta
//               : x3,y3,x4,y4=(float) coord.estremi della seconda retta
// VAR.RESTITUITE: *xi,*yi= (float) coord.del punto di intersezione
//		   (int) TRUE= se intersezione
//                       FALSE= non intersezione

// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce il punto di intersezione fra 2 rette
//Inoltre se 3 e 4 e' il lato opposto di un triangolo con vertice 1
//restituisce TRUE se il punto 2 e' all'interno del triangolo 134, FALSE se no
int Intersez(float x1,float y1,float x2,float y2,float x3,float y3,
	     float x4,float y4,float *xi,float *yi);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : AngTwoLine
// VAR.PASSATE   : Pt[3]= (float) coord.origine x,y,z
// VAR.RESTITUITE: Pt1[3],Pt2[3]= (float) coord. degli estremi delle rette
// INCLUDE       : math.h
// DESCRIZIONE   :
//Restituisce l'angolo fra due rette con origine comune Pt
double AngTwoLine(float Pt[3],float Pt1[3],float Pt2[3]);

//
//        by Diego Bonata 1997
//
// FUNZIONE      : LUNG
// VAR.PASSATE   : alfa,beta,gamma=(double) parametri della conica
//                 CERCHIO : alfa=1 beta=1 gamma=-2*Raggio (concava) + (convessa)
//                 ELLISSE : alfa=Semiasseminore^2   beta=Semiassemaggiore^2
//                 gamma=-2*Semiasseminore*Semiassemaggiore^2 (concava) + (convessa)
//                 IPERBOLE: alfa=-Semiasseminore^2  beta=Semiassemaggiore^2
//                 gamma=-2*Semiassemaggiore^2 (concava) + (convessa)
//                 PARABOLA: alfa=1/(2*Fuoco) beta=0  gamma=-1 (concava) + (convessa)
//                 Xini=(double) coordinata X di inizio della misura
//                 Xfin=(double) coordinata X di fine della misura
//                 DELTA=(double) approssimazione desiderata >0
// VAR.RESTITUITE: (double) lunghezza tratto di conica
// INCLUDE       : math.h
// DESCRIZIONE   :
// Funzione per calcolare la lunghezza di un arco di una funzione generica
// y=f(x) in coordinate polari
double LUNG(alfa,beta,gamma,Xini,Xfin,DELTA);

//aggiungere
/*
// Questa funzione trova il centroide di una serie di punti
// deve essere pero' resaa portabile
void Clustering(void)
{
int    i,P=0;
float  Xm,Ym,xp,x,yp,y,varX,varY,N;
struct xycoord *Cx,*Cy;
char   str[4];

 if (inizX && inizY) {
   for (P=-4;P<4;P++) {
    Cx=inizX;
    Cy=inizY;
    do {
       Cx->Flag=Cy->Flag=1;
       Cx = Cx->succ;
       Cy = Cy->succ;
    } while(Cx && Cy);
    do {
       Xm=Ym=xp=x=yp=y=0;
       Cx=inizX;
       Cy=inizY;
       do {
	  if (Cx->Flag && Cy->Flag) {
	     xp = xp + pow(Cx->Punto,P+1);
	     yp = yp + pow(Cy->Punto,P+1);
	     x  = x  + pow(Cx->Punto,P);
	     y  = y  + pow(Cy->Punto,P);
	  }
	  Cx = Cx->succ;
	  Cy = Cy->succ;
       } while(Cx && Cy);
       Xm=xp/x;
       Ym=yp/y;

       Cx=inizX;
       Cy=inizY;
       x=y=N=0;
       do {
	  if (Cx->Flag && Cy->Flag) {
	     x  = x  + pow(Cx->Punto - Xm,2);
	     y  = y  + pow(Cy->Punto - Ym,2);
	     N++;
	  }
	  Cx = Cx->succ;
	  Cy = Cy->succ;
       } while(Cx && Cy);
       varX = sqrt(x/N);
       varY = sqrt(y/N);

       Cx=inizX;
       Cy=inizY;
       i=0;
       do {
	  if (Cx->Flag && Cy->Flag) {
	     if (fabs(Cx->Punto-Xm)>2*varX) { Cx->Flag=Cy->Flag=0; i++;  }
	     if (fabs(Cy->Punto-Ym)>2*varY) { Cx->Flag=Cy->Flag=0; i++;  }
	  }
	  Cx = Cx->succ;
	  Cy = Cy->succ;
       } while(Cx && Cy);
       setcolor(RED);
       line(mx+Xm-2,my+Ym,mx+Xm+2,my+Ym);line(mx+Xm,my+Ym-2,mx+Xm,my+Ym+2);
       getch();
    }while(i);
    setcolor(LIGHTRED);
    line(mx+Xm-2,my+Ym,mx+Xm+2,my+Ym);line(mx+Xm,my+Ym-2,mx+Xm,my+Ym+2);
    sprintf(str,"%d",P);
    outtextxy(mx+Xm,my+Ym-10,str);
  }//for
 }    //if
}
*/

